// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: device.proto

#ifndef GOOGLE_PROTOBUF_INCLUDED_device_2eproto
#define GOOGLE_PROTOBUF_INCLUDED_device_2eproto

#include <limits>
#include <string>

#include <google/protobuf/port_def.inc>
#if PROTOBUF_VERSION < 3012000
#error This file was generated by a newer version of protoc which is
#error incompatible with your Protocol Buffer headers. Please update
#error your headers.
#endif
#if 3012004 < PROTOBUF_MIN_PROTOC_VERSION
#error This file was generated by an older version of protoc which is
#error incompatible with your Protocol Buffer headers. Please
#error regenerate this file with a newer version of protoc.
#endif

#include <google/protobuf/port_undef.inc>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/arena.h>
#include <google/protobuf/arenastring.h>
#include <google/protobuf/generated_message_table_driven.h>
#include <google/protobuf/generated_message_util.h>
#include <google/protobuf/inlined_string_field.h>
#include <google/protobuf/metadata_lite.h>
#include <google/protobuf/generated_message_reflection.h>
#include <google/protobuf/message.h>
#include <google/protobuf/repeated_field.h>  // IWYU pragma: export
#include <google/protobuf/extension_set.h>  // IWYU pragma: export
#include <google/protobuf/map.h>  // IWYU pragma: export
#include <google/protobuf/map_entry.h>
#include <google/protobuf/map_field_inl.h>
#include <google/protobuf/unknown_field_set.h>
#include "tango_enums.pb.h"
// @@protoc_insertion_point(includes)
#include <google/protobuf/port_def.inc>
#define PROTOBUF_INTERNAL_EXPORT_device_2eproto
PROTOBUF_NAMESPACE_OPEN
namespace internal {
class AnyMetadata;
}  // namespace internal
PROTOBUF_NAMESPACE_CLOSE

// Internal implementation detail -- do not use these members.
struct TableStruct_device_2eproto {
  static const ::PROTOBUF_NAMESPACE_ID::internal::ParseTableField entries[]
    PROTOBUF_SECTION_VARIABLE(protodesc_cold);
  static const ::PROTOBUF_NAMESPACE_ID::internal::AuxillaryParseTableField aux[]
    PROTOBUF_SECTION_VARIABLE(protodesc_cold);
  static const ::PROTOBUF_NAMESPACE_ID::internal::ParseTable schema[10]
    PROTOBUF_SECTION_VARIABLE(protodesc_cold);
  static const ::PROTOBUF_NAMESPACE_ID::internal::FieldMetadata field_metadata[];
  static const ::PROTOBUF_NAMESPACE_ID::internal::SerializationTable serialization_table[];
  static const ::PROTOBUF_NAMESPACE_ID::uint32 offsets[];
};
extern const ::PROTOBUF_NAMESPACE_ID::internal::DescriptorTable descriptor_table_device_2eproto;
namespace mascot {
class AttributeListReply;
class AttributeListReplyDefaultTypeInternal;
extern AttributeListReplyDefaultTypeInternal _AttributeListReply_default_instance_;
class CommandListReply;
class CommandListReplyDefaultTypeInternal;
extern CommandListReplyDefaultTypeInternal _CommandListReply_default_instance_;
class DeviceAttributeDescription;
class DeviceAttributeDescriptionDefaultTypeInternal;
extern DeviceAttributeDescriptionDefaultTypeInternal _DeviceAttributeDescription_default_instance_;
class DeviceCommandDescription;
class DeviceCommandDescriptionDefaultTypeInternal;
extern DeviceCommandDescriptionDefaultTypeInternal _DeviceCommandDescription_default_instance_;
class DeviceCommandDescription_ParametersEntry_DoNotUse;
class DeviceCommandDescription_ParametersEntry_DoNotUseDefaultTypeInternal;
extern DeviceCommandDescription_ParametersEntry_DoNotUseDefaultTypeInternal _DeviceCommandDescription_ParametersEntry_DoNotUse_default_instance_;
class DeviceCommandDescription_ReturnValuesEntry_DoNotUse;
class DeviceCommandDescription_ReturnValuesEntry_DoNotUseDefaultTypeInternal;
extern DeviceCommandDescription_ReturnValuesEntry_DoNotUseDefaultTypeInternal _DeviceCommandDescription_ReturnValuesEntry_DoNotUse_default_instance_;
class GetAttributeListMessage;
class GetAttributeListMessageDefaultTypeInternal;
extern GetAttributeListMessageDefaultTypeInternal _GetAttributeListMessage_default_instance_;
class GetCommandListMessage;
class GetCommandListMessageDefaultTypeInternal;
extern GetCommandListMessageDefaultTypeInternal _GetCommandListMessage_default_instance_;
class PingMessage;
class PingMessageDefaultTypeInternal;
extern PingMessageDefaultTypeInternal _PingMessage_default_instance_;
class PingReply;
class PingReplyDefaultTypeInternal;
extern PingReplyDefaultTypeInternal _PingReply_default_instance_;
}  // namespace mascot
PROTOBUF_NAMESPACE_OPEN
template<> ::mascot::AttributeListReply* Arena::CreateMaybeMessage<::mascot::AttributeListReply>(Arena*);
template<> ::mascot::CommandListReply* Arena::CreateMaybeMessage<::mascot::CommandListReply>(Arena*);
template<> ::mascot::DeviceAttributeDescription* Arena::CreateMaybeMessage<::mascot::DeviceAttributeDescription>(Arena*);
template<> ::mascot::DeviceCommandDescription* Arena::CreateMaybeMessage<::mascot::DeviceCommandDescription>(Arena*);
template<> ::mascot::DeviceCommandDescription_ParametersEntry_DoNotUse* Arena::CreateMaybeMessage<::mascot::DeviceCommandDescription_ParametersEntry_DoNotUse>(Arena*);
template<> ::mascot::DeviceCommandDescription_ReturnValuesEntry_DoNotUse* Arena::CreateMaybeMessage<::mascot::DeviceCommandDescription_ReturnValuesEntry_DoNotUse>(Arena*);
template<> ::mascot::GetAttributeListMessage* Arena::CreateMaybeMessage<::mascot::GetAttributeListMessage>(Arena*);
template<> ::mascot::GetCommandListMessage* Arena::CreateMaybeMessage<::mascot::GetCommandListMessage>(Arena*);
template<> ::mascot::PingMessage* Arena::CreateMaybeMessage<::mascot::PingMessage>(Arena*);
template<> ::mascot::PingReply* Arena::CreateMaybeMessage<::mascot::PingReply>(Arena*);
PROTOBUF_NAMESPACE_CLOSE
namespace mascot {

// ===================================================================

class GetAttributeListMessage PROTOBUF_FINAL :
    public ::PROTOBUF_NAMESPACE_ID::Message /* @@protoc_insertion_point(class_definition:mascot.GetAttributeListMessage) */ {
 public:
  inline GetAttributeListMessage() : GetAttributeListMessage(nullptr) {};
  virtual ~GetAttributeListMessage();

  GetAttributeListMessage(const GetAttributeListMessage& from);
  GetAttributeListMessage(GetAttributeListMessage&& from) noexcept
    : GetAttributeListMessage() {
    *this = ::std::move(from);
  }

  inline GetAttributeListMessage& operator=(const GetAttributeListMessage& from) {
    CopyFrom(from);
    return *this;
  }
  inline GetAttributeListMessage& operator=(GetAttributeListMessage&& from) noexcept {
    if (GetArena() == from.GetArena()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }

  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* descriptor() {
    return GetDescriptor();
  }
  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* GetDescriptor() {
    return GetMetadataStatic().descriptor;
  }
  static const ::PROTOBUF_NAMESPACE_ID::Reflection* GetReflection() {
    return GetMetadataStatic().reflection;
  }
  static const GetAttributeListMessage& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const GetAttributeListMessage* internal_default_instance() {
    return reinterpret_cast<const GetAttributeListMessage*>(
               &_GetAttributeListMessage_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    0;

  friend void swap(GetAttributeListMessage& a, GetAttributeListMessage& b) {
    a.Swap(&b);
  }
  inline void Swap(GetAttributeListMessage* other) {
    if (other == this) return;
    if (GetArena() == other->GetArena()) {
      InternalSwap(other);
    } else {
      ::PROTOBUF_NAMESPACE_ID::internal::GenericSwap(this, other);
    }
  }
  void UnsafeArenaSwap(GetAttributeListMessage* other) {
    if (other == this) return;
    GOOGLE_DCHECK(GetArena() == other->GetArena());
    InternalSwap(other);
  }

  // implements Message ----------------------------------------------

  inline GetAttributeListMessage* New() const final {
    return CreateMaybeMessage<GetAttributeListMessage>(nullptr);
  }

  GetAttributeListMessage* New(::PROTOBUF_NAMESPACE_ID::Arena* arena) const final {
    return CreateMaybeMessage<GetAttributeListMessage>(arena);
  }
  void CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void CopyFrom(const GetAttributeListMessage& from);
  void MergeFrom(const GetAttributeListMessage& from);
  PROTOBUF_ATTRIBUTE_REINITIALIZES void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  const char* _InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) final;
  ::PROTOBUF_NAMESPACE_ID::uint8* _InternalSerialize(
      ::PROTOBUF_NAMESPACE_ID::uint8* target, ::PROTOBUF_NAMESPACE_ID::io::EpsCopyOutputStream* stream) const final;
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  inline void SharedCtor();
  inline void SharedDtor();
  void SetCachedSize(int size) const final;
  void InternalSwap(GetAttributeListMessage* other);
  friend class ::PROTOBUF_NAMESPACE_ID::internal::AnyMetadata;
  static ::PROTOBUF_NAMESPACE_ID::StringPiece FullMessageName() {
    return "mascot.GetAttributeListMessage";
  }
  protected:
  explicit GetAttributeListMessage(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  private:
  static void ArenaDtor(void* object);
  inline void RegisterArenaDtor(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  public:

  ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadata() const final;
  private:
  static ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadataStatic() {
    ::PROTOBUF_NAMESPACE_ID::internal::AssignDescriptors(&::descriptor_table_device_2eproto);
    return ::descriptor_table_device_2eproto.file_level_metadata[kIndexInFileMessages];
  }

  public:

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // @@protoc_insertion_point(class_scope:mascot.GetAttributeListMessage)
 private:
  class _Internal;

  template <typename T> friend class ::PROTOBUF_NAMESPACE_ID::Arena::InternalHelper;
  typedef void InternalArenaConstructable_;
  typedef void DestructorSkippable_;
  mutable ::PROTOBUF_NAMESPACE_ID::internal::CachedSize _cached_size_;
  friend struct ::TableStruct_device_2eproto;
};
// -------------------------------------------------------------------

class GetCommandListMessage PROTOBUF_FINAL :
    public ::PROTOBUF_NAMESPACE_ID::Message /* @@protoc_insertion_point(class_definition:mascot.GetCommandListMessage) */ {
 public:
  inline GetCommandListMessage() : GetCommandListMessage(nullptr) {};
  virtual ~GetCommandListMessage();

  GetCommandListMessage(const GetCommandListMessage& from);
  GetCommandListMessage(GetCommandListMessage&& from) noexcept
    : GetCommandListMessage() {
    *this = ::std::move(from);
  }

  inline GetCommandListMessage& operator=(const GetCommandListMessage& from) {
    CopyFrom(from);
    return *this;
  }
  inline GetCommandListMessage& operator=(GetCommandListMessage&& from) noexcept {
    if (GetArena() == from.GetArena()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }

  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* descriptor() {
    return GetDescriptor();
  }
  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* GetDescriptor() {
    return GetMetadataStatic().descriptor;
  }
  static const ::PROTOBUF_NAMESPACE_ID::Reflection* GetReflection() {
    return GetMetadataStatic().reflection;
  }
  static const GetCommandListMessage& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const GetCommandListMessage* internal_default_instance() {
    return reinterpret_cast<const GetCommandListMessage*>(
               &_GetCommandListMessage_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    1;

  friend void swap(GetCommandListMessage& a, GetCommandListMessage& b) {
    a.Swap(&b);
  }
  inline void Swap(GetCommandListMessage* other) {
    if (other == this) return;
    if (GetArena() == other->GetArena()) {
      InternalSwap(other);
    } else {
      ::PROTOBUF_NAMESPACE_ID::internal::GenericSwap(this, other);
    }
  }
  void UnsafeArenaSwap(GetCommandListMessage* other) {
    if (other == this) return;
    GOOGLE_DCHECK(GetArena() == other->GetArena());
    InternalSwap(other);
  }

  // implements Message ----------------------------------------------

  inline GetCommandListMessage* New() const final {
    return CreateMaybeMessage<GetCommandListMessage>(nullptr);
  }

  GetCommandListMessage* New(::PROTOBUF_NAMESPACE_ID::Arena* arena) const final {
    return CreateMaybeMessage<GetCommandListMessage>(arena);
  }
  void CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void CopyFrom(const GetCommandListMessage& from);
  void MergeFrom(const GetCommandListMessage& from);
  PROTOBUF_ATTRIBUTE_REINITIALIZES void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  const char* _InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) final;
  ::PROTOBUF_NAMESPACE_ID::uint8* _InternalSerialize(
      ::PROTOBUF_NAMESPACE_ID::uint8* target, ::PROTOBUF_NAMESPACE_ID::io::EpsCopyOutputStream* stream) const final;
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  inline void SharedCtor();
  inline void SharedDtor();
  void SetCachedSize(int size) const final;
  void InternalSwap(GetCommandListMessage* other);
  friend class ::PROTOBUF_NAMESPACE_ID::internal::AnyMetadata;
  static ::PROTOBUF_NAMESPACE_ID::StringPiece FullMessageName() {
    return "mascot.GetCommandListMessage";
  }
  protected:
  explicit GetCommandListMessage(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  private:
  static void ArenaDtor(void* object);
  inline void RegisterArenaDtor(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  public:

  ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadata() const final;
  private:
  static ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadataStatic() {
    ::PROTOBUF_NAMESPACE_ID::internal::AssignDescriptors(&::descriptor_table_device_2eproto);
    return ::descriptor_table_device_2eproto.file_level_metadata[kIndexInFileMessages];
  }

  public:

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // @@protoc_insertion_point(class_scope:mascot.GetCommandListMessage)
 private:
  class _Internal;

  template <typename T> friend class ::PROTOBUF_NAMESPACE_ID::Arena::InternalHelper;
  typedef void InternalArenaConstructable_;
  typedef void DestructorSkippable_;
  mutable ::PROTOBUF_NAMESPACE_ID::internal::CachedSize _cached_size_;
  friend struct ::TableStruct_device_2eproto;
};
// -------------------------------------------------------------------

class DeviceAttributeDescription PROTOBUF_FINAL :
    public ::PROTOBUF_NAMESPACE_ID::Message /* @@protoc_insertion_point(class_definition:mascot.DeviceAttributeDescription) */ {
 public:
  inline DeviceAttributeDescription() : DeviceAttributeDescription(nullptr) {};
  virtual ~DeviceAttributeDescription();

  DeviceAttributeDescription(const DeviceAttributeDescription& from);
  DeviceAttributeDescription(DeviceAttributeDescription&& from) noexcept
    : DeviceAttributeDescription() {
    *this = ::std::move(from);
  }

  inline DeviceAttributeDescription& operator=(const DeviceAttributeDescription& from) {
    CopyFrom(from);
    return *this;
  }
  inline DeviceAttributeDescription& operator=(DeviceAttributeDescription&& from) noexcept {
    if (GetArena() == from.GetArena()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }

  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* descriptor() {
    return GetDescriptor();
  }
  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* GetDescriptor() {
    return GetMetadataStatic().descriptor;
  }
  static const ::PROTOBUF_NAMESPACE_ID::Reflection* GetReflection() {
    return GetMetadataStatic().reflection;
  }
  static const DeviceAttributeDescription& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const DeviceAttributeDescription* internal_default_instance() {
    return reinterpret_cast<const DeviceAttributeDescription*>(
               &_DeviceAttributeDescription_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    2;

  friend void swap(DeviceAttributeDescription& a, DeviceAttributeDescription& b) {
    a.Swap(&b);
  }
  inline void Swap(DeviceAttributeDescription* other) {
    if (other == this) return;
    if (GetArena() == other->GetArena()) {
      InternalSwap(other);
    } else {
      ::PROTOBUF_NAMESPACE_ID::internal::GenericSwap(this, other);
    }
  }
  void UnsafeArenaSwap(DeviceAttributeDescription* other) {
    if (other == this) return;
    GOOGLE_DCHECK(GetArena() == other->GetArena());
    InternalSwap(other);
  }

  // implements Message ----------------------------------------------

  inline DeviceAttributeDescription* New() const final {
    return CreateMaybeMessage<DeviceAttributeDescription>(nullptr);
  }

  DeviceAttributeDescription* New(::PROTOBUF_NAMESPACE_ID::Arena* arena) const final {
    return CreateMaybeMessage<DeviceAttributeDescription>(arena);
  }
  void CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void CopyFrom(const DeviceAttributeDescription& from);
  void MergeFrom(const DeviceAttributeDescription& from);
  PROTOBUF_ATTRIBUTE_REINITIALIZES void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  const char* _InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) final;
  ::PROTOBUF_NAMESPACE_ID::uint8* _InternalSerialize(
      ::PROTOBUF_NAMESPACE_ID::uint8* target, ::PROTOBUF_NAMESPACE_ID::io::EpsCopyOutputStream* stream) const final;
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  inline void SharedCtor();
  inline void SharedDtor();
  void SetCachedSize(int size) const final;
  void InternalSwap(DeviceAttributeDescription* other);
  friend class ::PROTOBUF_NAMESPACE_ID::internal::AnyMetadata;
  static ::PROTOBUF_NAMESPACE_ID::StringPiece FullMessageName() {
    return "mascot.DeviceAttributeDescription";
  }
  protected:
  explicit DeviceAttributeDescription(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  private:
  static void ArenaDtor(void* object);
  inline void RegisterArenaDtor(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  public:

  ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadata() const final;
  private:
  static ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadataStatic() {
    ::PROTOBUF_NAMESPACE_ID::internal::AssignDescriptors(&::descriptor_table_device_2eproto);
    return ::descriptor_table_device_2eproto.file_level_metadata[kIndexInFileMessages];
  }

  public:

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  enum : int {
    kNameFieldNumber = 1,
    kDataTypeFieldNumber = 2,
    kWritableFieldNumber = 3,
  };
  // string name = 1;
  void clear_name();
  const std::string& name() const;
  void set_name(const std::string& value);
  void set_name(std::string&& value);
  void set_name(const char* value);
  void set_name(const char* value, size_t size);
  std::string* mutable_name();
  std::string* release_name();
  void set_allocated_name(std::string* name);
  GOOGLE_PROTOBUF_RUNTIME_DEPRECATED("The unsafe_arena_ accessors for"
  "    string fields are deprecated and will be removed in a"
  "    future release.")
  std::string* unsafe_arena_release_name();
  GOOGLE_PROTOBUF_RUNTIME_DEPRECATED("The unsafe_arena_ accessors for"
  "    string fields are deprecated and will be removed in a"
  "    future release.")
  void unsafe_arena_set_allocated_name(
      std::string* name);
  private:
  const std::string& _internal_name() const;
  void _internal_set_name(const std::string& value);
  std::string* _internal_mutable_name();
  public:

  // .mascot.CmdArgType dataType = 2;
  void clear_datatype();
  ::mascot::CmdArgType datatype() const;
  void set_datatype(::mascot::CmdArgType value);
  private:
  ::mascot::CmdArgType _internal_datatype() const;
  void _internal_set_datatype(::mascot::CmdArgType value);
  public:

  // bool writable = 3;
  void clear_writable();
  bool writable() const;
  void set_writable(bool value);
  private:
  bool _internal_writable() const;
  void _internal_set_writable(bool value);
  public:

  // @@protoc_insertion_point(class_scope:mascot.DeviceAttributeDescription)
 private:
  class _Internal;

  template <typename T> friend class ::PROTOBUF_NAMESPACE_ID::Arena::InternalHelper;
  typedef void InternalArenaConstructable_;
  typedef void DestructorSkippable_;
  ::PROTOBUF_NAMESPACE_ID::internal::ArenaStringPtr name_;
  int datatype_;
  bool writable_;
  mutable ::PROTOBUF_NAMESPACE_ID::internal::CachedSize _cached_size_;
  friend struct ::TableStruct_device_2eproto;
};
// -------------------------------------------------------------------

class AttributeListReply PROTOBUF_FINAL :
    public ::PROTOBUF_NAMESPACE_ID::Message /* @@protoc_insertion_point(class_definition:mascot.AttributeListReply) */ {
 public:
  inline AttributeListReply() : AttributeListReply(nullptr) {};
  virtual ~AttributeListReply();

  AttributeListReply(const AttributeListReply& from);
  AttributeListReply(AttributeListReply&& from) noexcept
    : AttributeListReply() {
    *this = ::std::move(from);
  }

  inline AttributeListReply& operator=(const AttributeListReply& from) {
    CopyFrom(from);
    return *this;
  }
  inline AttributeListReply& operator=(AttributeListReply&& from) noexcept {
    if (GetArena() == from.GetArena()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }

  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* descriptor() {
    return GetDescriptor();
  }
  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* GetDescriptor() {
    return GetMetadataStatic().descriptor;
  }
  static const ::PROTOBUF_NAMESPACE_ID::Reflection* GetReflection() {
    return GetMetadataStatic().reflection;
  }
  static const AttributeListReply& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const AttributeListReply* internal_default_instance() {
    return reinterpret_cast<const AttributeListReply*>(
               &_AttributeListReply_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    3;

  friend void swap(AttributeListReply& a, AttributeListReply& b) {
    a.Swap(&b);
  }
  inline void Swap(AttributeListReply* other) {
    if (other == this) return;
    if (GetArena() == other->GetArena()) {
      InternalSwap(other);
    } else {
      ::PROTOBUF_NAMESPACE_ID::internal::GenericSwap(this, other);
    }
  }
  void UnsafeArenaSwap(AttributeListReply* other) {
    if (other == this) return;
    GOOGLE_DCHECK(GetArena() == other->GetArena());
    InternalSwap(other);
  }

  // implements Message ----------------------------------------------

  inline AttributeListReply* New() const final {
    return CreateMaybeMessage<AttributeListReply>(nullptr);
  }

  AttributeListReply* New(::PROTOBUF_NAMESPACE_ID::Arena* arena) const final {
    return CreateMaybeMessage<AttributeListReply>(arena);
  }
  void CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void CopyFrom(const AttributeListReply& from);
  void MergeFrom(const AttributeListReply& from);
  PROTOBUF_ATTRIBUTE_REINITIALIZES void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  const char* _InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) final;
  ::PROTOBUF_NAMESPACE_ID::uint8* _InternalSerialize(
      ::PROTOBUF_NAMESPACE_ID::uint8* target, ::PROTOBUF_NAMESPACE_ID::io::EpsCopyOutputStream* stream) const final;
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  inline void SharedCtor();
  inline void SharedDtor();
  void SetCachedSize(int size) const final;
  void InternalSwap(AttributeListReply* other);
  friend class ::PROTOBUF_NAMESPACE_ID::internal::AnyMetadata;
  static ::PROTOBUF_NAMESPACE_ID::StringPiece FullMessageName() {
    return "mascot.AttributeListReply";
  }
  protected:
  explicit AttributeListReply(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  private:
  static void ArenaDtor(void* object);
  inline void RegisterArenaDtor(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  public:

  ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadata() const final;
  private:
  static ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadataStatic() {
    ::PROTOBUF_NAMESPACE_ID::internal::AssignDescriptors(&::descriptor_table_device_2eproto);
    return ::descriptor_table_device_2eproto.file_level_metadata[kIndexInFileMessages];
  }

  public:

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  enum : int {
    kAttributesFieldNumber = 1,
  };
  // repeated .mascot.DeviceAttributeDescription attributes = 1;
  int attributes_size() const;
  private:
  int _internal_attributes_size() const;
  public:
  void clear_attributes();
  ::mascot::DeviceAttributeDescription* mutable_attributes(int index);
  ::PROTOBUF_NAMESPACE_ID::RepeatedPtrField< ::mascot::DeviceAttributeDescription >*
      mutable_attributes();
  private:
  const ::mascot::DeviceAttributeDescription& _internal_attributes(int index) const;
  ::mascot::DeviceAttributeDescription* _internal_add_attributes();
  public:
  const ::mascot::DeviceAttributeDescription& attributes(int index) const;
  ::mascot::DeviceAttributeDescription* add_attributes();
  const ::PROTOBUF_NAMESPACE_ID::RepeatedPtrField< ::mascot::DeviceAttributeDescription >&
      attributes() const;

  // @@protoc_insertion_point(class_scope:mascot.AttributeListReply)
 private:
  class _Internal;

  template <typename T> friend class ::PROTOBUF_NAMESPACE_ID::Arena::InternalHelper;
  typedef void InternalArenaConstructable_;
  typedef void DestructorSkippable_;
  ::PROTOBUF_NAMESPACE_ID::RepeatedPtrField< ::mascot::DeviceAttributeDescription > attributes_;
  mutable ::PROTOBUF_NAMESPACE_ID::internal::CachedSize _cached_size_;
  friend struct ::TableStruct_device_2eproto;
};
// -------------------------------------------------------------------

class DeviceCommandDescription_ParametersEntry_DoNotUse : public ::PROTOBUF_NAMESPACE_ID::internal::MapEntry<DeviceCommandDescription_ParametersEntry_DoNotUse, 
    std::string, ::mascot::CmdArgType,
    ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::TYPE_STRING,
    ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::TYPE_ENUM,
    0 > {
public:
  typedef ::PROTOBUF_NAMESPACE_ID::internal::MapEntry<DeviceCommandDescription_ParametersEntry_DoNotUse, 
    std::string, ::mascot::CmdArgType,
    ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::TYPE_STRING,
    ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::TYPE_ENUM,
    0 > SuperType;
  DeviceCommandDescription_ParametersEntry_DoNotUse();
  DeviceCommandDescription_ParametersEntry_DoNotUse(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  void MergeFrom(const DeviceCommandDescription_ParametersEntry_DoNotUse& other);
  static const DeviceCommandDescription_ParametersEntry_DoNotUse* internal_default_instance() { return reinterpret_cast<const DeviceCommandDescription_ParametersEntry_DoNotUse*>(&_DeviceCommandDescription_ParametersEntry_DoNotUse_default_instance_); }
  static bool ValidateKey(std::string* s) {
    return ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::VerifyUtf8String(s->data(), static_cast<int>(s->size()), ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::PARSE, "mascot.DeviceCommandDescription.ParametersEntry.key");
 }
  static bool ValidateValue(void*) { return true; }
  void MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& other) final;
  ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadata() const final;
  private:
  static ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadataStatic() {
    ::PROTOBUF_NAMESPACE_ID::internal::AssignDescriptors(&::descriptor_table_device_2eproto);
    return ::descriptor_table_device_2eproto.file_level_metadata[4];
  }

  public:
};

// -------------------------------------------------------------------

class DeviceCommandDescription_ReturnValuesEntry_DoNotUse : public ::PROTOBUF_NAMESPACE_ID::internal::MapEntry<DeviceCommandDescription_ReturnValuesEntry_DoNotUse, 
    std::string, ::mascot::CmdArgType,
    ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::TYPE_STRING,
    ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::TYPE_ENUM,
    0 > {
public:
  typedef ::PROTOBUF_NAMESPACE_ID::internal::MapEntry<DeviceCommandDescription_ReturnValuesEntry_DoNotUse, 
    std::string, ::mascot::CmdArgType,
    ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::TYPE_STRING,
    ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::TYPE_ENUM,
    0 > SuperType;
  DeviceCommandDescription_ReturnValuesEntry_DoNotUse();
  DeviceCommandDescription_ReturnValuesEntry_DoNotUse(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  void MergeFrom(const DeviceCommandDescription_ReturnValuesEntry_DoNotUse& other);
  static const DeviceCommandDescription_ReturnValuesEntry_DoNotUse* internal_default_instance() { return reinterpret_cast<const DeviceCommandDescription_ReturnValuesEntry_DoNotUse*>(&_DeviceCommandDescription_ReturnValuesEntry_DoNotUse_default_instance_); }
  static bool ValidateKey(std::string* s) {
    return ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::VerifyUtf8String(s->data(), static_cast<int>(s->size()), ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::PARSE, "mascot.DeviceCommandDescription.ReturnValuesEntry.key");
 }
  static bool ValidateValue(void*) { return true; }
  void MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& other) final;
  ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadata() const final;
  private:
  static ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadataStatic() {
    ::PROTOBUF_NAMESPACE_ID::internal::AssignDescriptors(&::descriptor_table_device_2eproto);
    return ::descriptor_table_device_2eproto.file_level_metadata[5];
  }

  public:
};

// -------------------------------------------------------------------

class DeviceCommandDescription PROTOBUF_FINAL :
    public ::PROTOBUF_NAMESPACE_ID::Message /* @@protoc_insertion_point(class_definition:mascot.DeviceCommandDescription) */ {
 public:
  inline DeviceCommandDescription() : DeviceCommandDescription(nullptr) {};
  virtual ~DeviceCommandDescription();

  DeviceCommandDescription(const DeviceCommandDescription& from);
  DeviceCommandDescription(DeviceCommandDescription&& from) noexcept
    : DeviceCommandDescription() {
    *this = ::std::move(from);
  }

  inline DeviceCommandDescription& operator=(const DeviceCommandDescription& from) {
    CopyFrom(from);
    return *this;
  }
  inline DeviceCommandDescription& operator=(DeviceCommandDescription&& from) noexcept {
    if (GetArena() == from.GetArena()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }

  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* descriptor() {
    return GetDescriptor();
  }
  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* GetDescriptor() {
    return GetMetadataStatic().descriptor;
  }
  static const ::PROTOBUF_NAMESPACE_ID::Reflection* GetReflection() {
    return GetMetadataStatic().reflection;
  }
  static const DeviceCommandDescription& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const DeviceCommandDescription* internal_default_instance() {
    return reinterpret_cast<const DeviceCommandDescription*>(
               &_DeviceCommandDescription_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    6;

  friend void swap(DeviceCommandDescription& a, DeviceCommandDescription& b) {
    a.Swap(&b);
  }
  inline void Swap(DeviceCommandDescription* other) {
    if (other == this) return;
    if (GetArena() == other->GetArena()) {
      InternalSwap(other);
    } else {
      ::PROTOBUF_NAMESPACE_ID::internal::GenericSwap(this, other);
    }
  }
  void UnsafeArenaSwap(DeviceCommandDescription* other) {
    if (other == this) return;
    GOOGLE_DCHECK(GetArena() == other->GetArena());
    InternalSwap(other);
  }

  // implements Message ----------------------------------------------

  inline DeviceCommandDescription* New() const final {
    return CreateMaybeMessage<DeviceCommandDescription>(nullptr);
  }

  DeviceCommandDescription* New(::PROTOBUF_NAMESPACE_ID::Arena* arena) const final {
    return CreateMaybeMessage<DeviceCommandDescription>(arena);
  }
  void CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void CopyFrom(const DeviceCommandDescription& from);
  void MergeFrom(const DeviceCommandDescription& from);
  PROTOBUF_ATTRIBUTE_REINITIALIZES void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  const char* _InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) final;
  ::PROTOBUF_NAMESPACE_ID::uint8* _InternalSerialize(
      ::PROTOBUF_NAMESPACE_ID::uint8* target, ::PROTOBUF_NAMESPACE_ID::io::EpsCopyOutputStream* stream) const final;
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  inline void SharedCtor();
  inline void SharedDtor();
  void SetCachedSize(int size) const final;
  void InternalSwap(DeviceCommandDescription* other);
  friend class ::PROTOBUF_NAMESPACE_ID::internal::AnyMetadata;
  static ::PROTOBUF_NAMESPACE_ID::StringPiece FullMessageName() {
    return "mascot.DeviceCommandDescription";
  }
  protected:
  explicit DeviceCommandDescription(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  private:
  static void ArenaDtor(void* object);
  inline void RegisterArenaDtor(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  public:

  ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadata() const final;
  private:
  static ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadataStatic() {
    ::PROTOBUF_NAMESPACE_ID::internal::AssignDescriptors(&::descriptor_table_device_2eproto);
    return ::descriptor_table_device_2eproto.file_level_metadata[kIndexInFileMessages];
  }

  public:

  // nested types ----------------------------------------------------


  // accessors -------------------------------------------------------

  enum : int {
    kParametersFieldNumber = 2,
    kReturnValuesFieldNumber = 3,
    kNameFieldNumber = 1,
  };
  // map<string, .mascot.CmdArgType> parameters = 2;
  int parameters_size() const;
  private:
  int _internal_parameters_size() const;
  public:
  void clear_parameters();
  private:
  const ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >&
      _internal_parameters() const;
  ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >*
      _internal_mutable_parameters();
  public:
  const ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >&
      parameters() const;
  ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >*
      mutable_parameters();

  // map<string, .mascot.CmdArgType> returnValues = 3;
  int returnvalues_size() const;
  private:
  int _internal_returnvalues_size() const;
  public:
  void clear_returnvalues();
  private:
  const ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >&
      _internal_returnvalues() const;
  ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >*
      _internal_mutable_returnvalues();
  public:
  const ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >&
      returnvalues() const;
  ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >*
      mutable_returnvalues();

  // string name = 1;
  void clear_name();
  const std::string& name() const;
  void set_name(const std::string& value);
  void set_name(std::string&& value);
  void set_name(const char* value);
  void set_name(const char* value, size_t size);
  std::string* mutable_name();
  std::string* release_name();
  void set_allocated_name(std::string* name);
  GOOGLE_PROTOBUF_RUNTIME_DEPRECATED("The unsafe_arena_ accessors for"
  "    string fields are deprecated and will be removed in a"
  "    future release.")
  std::string* unsafe_arena_release_name();
  GOOGLE_PROTOBUF_RUNTIME_DEPRECATED("The unsafe_arena_ accessors for"
  "    string fields are deprecated and will be removed in a"
  "    future release.")
  void unsafe_arena_set_allocated_name(
      std::string* name);
  private:
  const std::string& _internal_name() const;
  void _internal_set_name(const std::string& value);
  std::string* _internal_mutable_name();
  public:

  // @@protoc_insertion_point(class_scope:mascot.DeviceCommandDescription)
 private:
  class _Internal;

  template <typename T> friend class ::PROTOBUF_NAMESPACE_ID::Arena::InternalHelper;
  typedef void InternalArenaConstructable_;
  typedef void DestructorSkippable_;
  ::PROTOBUF_NAMESPACE_ID::internal::MapField<
      DeviceCommandDescription_ParametersEntry_DoNotUse,
      std::string, ::mascot::CmdArgType,
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::TYPE_STRING,
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::TYPE_ENUM,
      0 > parameters_;
  ::PROTOBUF_NAMESPACE_ID::internal::MapField<
      DeviceCommandDescription_ReturnValuesEntry_DoNotUse,
      std::string, ::mascot::CmdArgType,
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::TYPE_STRING,
      ::PROTOBUF_NAMESPACE_ID::internal::WireFormatLite::TYPE_ENUM,
      0 > returnvalues_;
  ::PROTOBUF_NAMESPACE_ID::internal::ArenaStringPtr name_;
  mutable ::PROTOBUF_NAMESPACE_ID::internal::CachedSize _cached_size_;
  friend struct ::TableStruct_device_2eproto;
};
// -------------------------------------------------------------------

class CommandListReply PROTOBUF_FINAL :
    public ::PROTOBUF_NAMESPACE_ID::Message /* @@protoc_insertion_point(class_definition:mascot.CommandListReply) */ {
 public:
  inline CommandListReply() : CommandListReply(nullptr) {};
  virtual ~CommandListReply();

  CommandListReply(const CommandListReply& from);
  CommandListReply(CommandListReply&& from) noexcept
    : CommandListReply() {
    *this = ::std::move(from);
  }

  inline CommandListReply& operator=(const CommandListReply& from) {
    CopyFrom(from);
    return *this;
  }
  inline CommandListReply& operator=(CommandListReply&& from) noexcept {
    if (GetArena() == from.GetArena()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }

  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* descriptor() {
    return GetDescriptor();
  }
  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* GetDescriptor() {
    return GetMetadataStatic().descriptor;
  }
  static const ::PROTOBUF_NAMESPACE_ID::Reflection* GetReflection() {
    return GetMetadataStatic().reflection;
  }
  static const CommandListReply& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const CommandListReply* internal_default_instance() {
    return reinterpret_cast<const CommandListReply*>(
               &_CommandListReply_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    7;

  friend void swap(CommandListReply& a, CommandListReply& b) {
    a.Swap(&b);
  }
  inline void Swap(CommandListReply* other) {
    if (other == this) return;
    if (GetArena() == other->GetArena()) {
      InternalSwap(other);
    } else {
      ::PROTOBUF_NAMESPACE_ID::internal::GenericSwap(this, other);
    }
  }
  void UnsafeArenaSwap(CommandListReply* other) {
    if (other == this) return;
    GOOGLE_DCHECK(GetArena() == other->GetArena());
    InternalSwap(other);
  }

  // implements Message ----------------------------------------------

  inline CommandListReply* New() const final {
    return CreateMaybeMessage<CommandListReply>(nullptr);
  }

  CommandListReply* New(::PROTOBUF_NAMESPACE_ID::Arena* arena) const final {
    return CreateMaybeMessage<CommandListReply>(arena);
  }
  void CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void CopyFrom(const CommandListReply& from);
  void MergeFrom(const CommandListReply& from);
  PROTOBUF_ATTRIBUTE_REINITIALIZES void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  const char* _InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) final;
  ::PROTOBUF_NAMESPACE_ID::uint8* _InternalSerialize(
      ::PROTOBUF_NAMESPACE_ID::uint8* target, ::PROTOBUF_NAMESPACE_ID::io::EpsCopyOutputStream* stream) const final;
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  inline void SharedCtor();
  inline void SharedDtor();
  void SetCachedSize(int size) const final;
  void InternalSwap(CommandListReply* other);
  friend class ::PROTOBUF_NAMESPACE_ID::internal::AnyMetadata;
  static ::PROTOBUF_NAMESPACE_ID::StringPiece FullMessageName() {
    return "mascot.CommandListReply";
  }
  protected:
  explicit CommandListReply(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  private:
  static void ArenaDtor(void* object);
  inline void RegisterArenaDtor(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  public:

  ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadata() const final;
  private:
  static ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadataStatic() {
    ::PROTOBUF_NAMESPACE_ID::internal::AssignDescriptors(&::descriptor_table_device_2eproto);
    return ::descriptor_table_device_2eproto.file_level_metadata[kIndexInFileMessages];
  }

  public:

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  enum : int {
    kCommandsFieldNumber = 1,
  };
  // repeated .mascot.DeviceCommandDescription commands = 1;
  int commands_size() const;
  private:
  int _internal_commands_size() const;
  public:
  void clear_commands();
  ::mascot::DeviceCommandDescription* mutable_commands(int index);
  ::PROTOBUF_NAMESPACE_ID::RepeatedPtrField< ::mascot::DeviceCommandDescription >*
      mutable_commands();
  private:
  const ::mascot::DeviceCommandDescription& _internal_commands(int index) const;
  ::mascot::DeviceCommandDescription* _internal_add_commands();
  public:
  const ::mascot::DeviceCommandDescription& commands(int index) const;
  ::mascot::DeviceCommandDescription* add_commands();
  const ::PROTOBUF_NAMESPACE_ID::RepeatedPtrField< ::mascot::DeviceCommandDescription >&
      commands() const;

  // @@protoc_insertion_point(class_scope:mascot.CommandListReply)
 private:
  class _Internal;

  template <typename T> friend class ::PROTOBUF_NAMESPACE_ID::Arena::InternalHelper;
  typedef void InternalArenaConstructable_;
  typedef void DestructorSkippable_;
  ::PROTOBUF_NAMESPACE_ID::RepeatedPtrField< ::mascot::DeviceCommandDescription > commands_;
  mutable ::PROTOBUF_NAMESPACE_ID::internal::CachedSize _cached_size_;
  friend struct ::TableStruct_device_2eproto;
};
// -------------------------------------------------------------------

class PingMessage PROTOBUF_FINAL :
    public ::PROTOBUF_NAMESPACE_ID::Message /* @@protoc_insertion_point(class_definition:mascot.PingMessage) */ {
 public:
  inline PingMessage() : PingMessage(nullptr) {};
  virtual ~PingMessage();

  PingMessage(const PingMessage& from);
  PingMessage(PingMessage&& from) noexcept
    : PingMessage() {
    *this = ::std::move(from);
  }

  inline PingMessage& operator=(const PingMessage& from) {
    CopyFrom(from);
    return *this;
  }
  inline PingMessage& operator=(PingMessage&& from) noexcept {
    if (GetArena() == from.GetArena()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }

  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* descriptor() {
    return GetDescriptor();
  }
  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* GetDescriptor() {
    return GetMetadataStatic().descriptor;
  }
  static const ::PROTOBUF_NAMESPACE_ID::Reflection* GetReflection() {
    return GetMetadataStatic().reflection;
  }
  static const PingMessage& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const PingMessage* internal_default_instance() {
    return reinterpret_cast<const PingMessage*>(
               &_PingMessage_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    8;

  friend void swap(PingMessage& a, PingMessage& b) {
    a.Swap(&b);
  }
  inline void Swap(PingMessage* other) {
    if (other == this) return;
    if (GetArena() == other->GetArena()) {
      InternalSwap(other);
    } else {
      ::PROTOBUF_NAMESPACE_ID::internal::GenericSwap(this, other);
    }
  }
  void UnsafeArenaSwap(PingMessage* other) {
    if (other == this) return;
    GOOGLE_DCHECK(GetArena() == other->GetArena());
    InternalSwap(other);
  }

  // implements Message ----------------------------------------------

  inline PingMessage* New() const final {
    return CreateMaybeMessage<PingMessage>(nullptr);
  }

  PingMessage* New(::PROTOBUF_NAMESPACE_ID::Arena* arena) const final {
    return CreateMaybeMessage<PingMessage>(arena);
  }
  void CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void CopyFrom(const PingMessage& from);
  void MergeFrom(const PingMessage& from);
  PROTOBUF_ATTRIBUTE_REINITIALIZES void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  const char* _InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) final;
  ::PROTOBUF_NAMESPACE_ID::uint8* _InternalSerialize(
      ::PROTOBUF_NAMESPACE_ID::uint8* target, ::PROTOBUF_NAMESPACE_ID::io::EpsCopyOutputStream* stream) const final;
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  inline void SharedCtor();
  inline void SharedDtor();
  void SetCachedSize(int size) const final;
  void InternalSwap(PingMessage* other);
  friend class ::PROTOBUF_NAMESPACE_ID::internal::AnyMetadata;
  static ::PROTOBUF_NAMESPACE_ID::StringPiece FullMessageName() {
    return "mascot.PingMessage";
  }
  protected:
  explicit PingMessage(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  private:
  static void ArenaDtor(void* object);
  inline void RegisterArenaDtor(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  public:

  ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadata() const final;
  private:
  static ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadataStatic() {
    ::PROTOBUF_NAMESPACE_ID::internal::AssignDescriptors(&::descriptor_table_device_2eproto);
    return ::descriptor_table_device_2eproto.file_level_metadata[kIndexInFileMessages];
  }

  public:

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // @@protoc_insertion_point(class_scope:mascot.PingMessage)
 private:
  class _Internal;

  template <typename T> friend class ::PROTOBUF_NAMESPACE_ID::Arena::InternalHelper;
  typedef void InternalArenaConstructable_;
  typedef void DestructorSkippable_;
  mutable ::PROTOBUF_NAMESPACE_ID::internal::CachedSize _cached_size_;
  friend struct ::TableStruct_device_2eproto;
};
// -------------------------------------------------------------------

class PingReply PROTOBUF_FINAL :
    public ::PROTOBUF_NAMESPACE_ID::Message /* @@protoc_insertion_point(class_definition:mascot.PingReply) */ {
 public:
  inline PingReply() : PingReply(nullptr) {};
  virtual ~PingReply();

  PingReply(const PingReply& from);
  PingReply(PingReply&& from) noexcept
    : PingReply() {
    *this = ::std::move(from);
  }

  inline PingReply& operator=(const PingReply& from) {
    CopyFrom(from);
    return *this;
  }
  inline PingReply& operator=(PingReply&& from) noexcept {
    if (GetArena() == from.GetArena()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }

  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* descriptor() {
    return GetDescriptor();
  }
  static const ::PROTOBUF_NAMESPACE_ID::Descriptor* GetDescriptor() {
    return GetMetadataStatic().descriptor;
  }
  static const ::PROTOBUF_NAMESPACE_ID::Reflection* GetReflection() {
    return GetMetadataStatic().reflection;
  }
  static const PingReply& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const PingReply* internal_default_instance() {
    return reinterpret_cast<const PingReply*>(
               &_PingReply_default_instance_);
  }
  static constexpr int kIndexInFileMessages =
    9;

  friend void swap(PingReply& a, PingReply& b) {
    a.Swap(&b);
  }
  inline void Swap(PingReply* other) {
    if (other == this) return;
    if (GetArena() == other->GetArena()) {
      InternalSwap(other);
    } else {
      ::PROTOBUF_NAMESPACE_ID::internal::GenericSwap(this, other);
    }
  }
  void UnsafeArenaSwap(PingReply* other) {
    if (other == this) return;
    GOOGLE_DCHECK(GetArena() == other->GetArena());
    InternalSwap(other);
  }

  // implements Message ----------------------------------------------

  inline PingReply* New() const final {
    return CreateMaybeMessage<PingReply>(nullptr);
  }

  PingReply* New(::PROTOBUF_NAMESPACE_ID::Arena* arena) const final {
    return CreateMaybeMessage<PingReply>(arena);
  }
  void CopyFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void MergeFrom(const ::PROTOBUF_NAMESPACE_ID::Message& from) final;
  void CopyFrom(const PingReply& from);
  void MergeFrom(const PingReply& from);
  PROTOBUF_ATTRIBUTE_REINITIALIZES void Clear() final;
  bool IsInitialized() const final;

  size_t ByteSizeLong() const final;
  const char* _InternalParse(const char* ptr, ::PROTOBUF_NAMESPACE_ID::internal::ParseContext* ctx) final;
  ::PROTOBUF_NAMESPACE_ID::uint8* _InternalSerialize(
      ::PROTOBUF_NAMESPACE_ID::uint8* target, ::PROTOBUF_NAMESPACE_ID::io::EpsCopyOutputStream* stream) const final;
  int GetCachedSize() const final { return _cached_size_.Get(); }

  private:
  inline void SharedCtor();
  inline void SharedDtor();
  void SetCachedSize(int size) const final;
  void InternalSwap(PingReply* other);
  friend class ::PROTOBUF_NAMESPACE_ID::internal::AnyMetadata;
  static ::PROTOBUF_NAMESPACE_ID::StringPiece FullMessageName() {
    return "mascot.PingReply";
  }
  protected:
  explicit PingReply(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  private:
  static void ArenaDtor(void* object);
  inline void RegisterArenaDtor(::PROTOBUF_NAMESPACE_ID::Arena* arena);
  public:

  ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadata() const final;
  private:
  static ::PROTOBUF_NAMESPACE_ID::Metadata GetMetadataStatic() {
    ::PROTOBUF_NAMESPACE_ID::internal::AssignDescriptors(&::descriptor_table_device_2eproto);
    return ::descriptor_table_device_2eproto.file_level_metadata[kIndexInFileMessages];
  }

  public:

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  enum : int {
    kTimeFieldNumber = 1,
  };
  // int64 time = 1;
  void clear_time();
  ::PROTOBUF_NAMESPACE_ID::int64 time() const;
  void set_time(::PROTOBUF_NAMESPACE_ID::int64 value);
  private:
  ::PROTOBUF_NAMESPACE_ID::int64 _internal_time() const;
  void _internal_set_time(::PROTOBUF_NAMESPACE_ID::int64 value);
  public:

  // @@protoc_insertion_point(class_scope:mascot.PingReply)
 private:
  class _Internal;

  template <typename T> friend class ::PROTOBUF_NAMESPACE_ID::Arena::InternalHelper;
  typedef void InternalArenaConstructable_;
  typedef void DestructorSkippable_;
  ::PROTOBUF_NAMESPACE_ID::int64 time_;
  mutable ::PROTOBUF_NAMESPACE_ID::internal::CachedSize _cached_size_;
  friend struct ::TableStruct_device_2eproto;
};
// ===================================================================


// ===================================================================

#ifdef __GNUC__
  #pragma GCC diagnostic push
  #pragma GCC diagnostic ignored "-Wstrict-aliasing"
#endif  // __GNUC__
// GetAttributeListMessage

// -------------------------------------------------------------------

// GetCommandListMessage

// -------------------------------------------------------------------

// DeviceAttributeDescription

// string name = 1;
inline void DeviceAttributeDescription::clear_name() {
  name_.ClearToEmpty(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
}
inline const std::string& DeviceAttributeDescription::name() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttributeDescription.name)
  return _internal_name();
}
inline void DeviceAttributeDescription::set_name(const std::string& value) {
  _internal_set_name(value);
  // @@protoc_insertion_point(field_set:mascot.DeviceAttributeDescription.name)
}
inline std::string* DeviceAttributeDescription::mutable_name() {
  // @@protoc_insertion_point(field_mutable:mascot.DeviceAttributeDescription.name)
  return _internal_mutable_name();
}
inline const std::string& DeviceAttributeDescription::_internal_name() const {
  return name_.Get();
}
inline void DeviceAttributeDescription::_internal_set_name(const std::string& value) {
  
  name_.Set(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), value, GetArena());
}
inline void DeviceAttributeDescription::set_name(std::string&& value) {
  
  name_.Set(
    &::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::move(value), GetArena());
  // @@protoc_insertion_point(field_set_rvalue:mascot.DeviceAttributeDescription.name)
}
inline void DeviceAttributeDescription::set_name(const char* value) {
  GOOGLE_DCHECK(value != nullptr);
  
  name_.Set(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::string(value),
              GetArena());
  // @@protoc_insertion_point(field_set_char:mascot.DeviceAttributeDescription.name)
}
inline void DeviceAttributeDescription::set_name(const char* value,
    size_t size) {
  
  name_.Set(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::string(
      reinterpret_cast<const char*>(value), size), GetArena());
  // @@protoc_insertion_point(field_set_pointer:mascot.DeviceAttributeDescription.name)
}
inline std::string* DeviceAttributeDescription::_internal_mutable_name() {
  
  return name_.Mutable(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
}
inline std::string* DeviceAttributeDescription::release_name() {
  // @@protoc_insertion_point(field_release:mascot.DeviceAttributeDescription.name)
  return name_.Release(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
}
inline void DeviceAttributeDescription::set_allocated_name(std::string* name) {
  if (name != nullptr) {
    
  } else {
    
  }
  name_.SetAllocated(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), name,
      GetArena());
  // @@protoc_insertion_point(field_set_allocated:mascot.DeviceAttributeDescription.name)
}
inline std::string* DeviceAttributeDescription::unsafe_arena_release_name() {
  // @@protoc_insertion_point(field_unsafe_arena_release:mascot.DeviceAttributeDescription.name)
  GOOGLE_DCHECK(GetArena() != nullptr);
  
  return name_.UnsafeArenaRelease(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(),
      GetArena());
}
inline void DeviceAttributeDescription::unsafe_arena_set_allocated_name(
    std::string* name) {
  GOOGLE_DCHECK(GetArena() != nullptr);
  if (name != nullptr) {
    
  } else {
    
  }
  name_.UnsafeArenaSetAllocated(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(),
      name, GetArena());
  // @@protoc_insertion_point(field_unsafe_arena_set_allocated:mascot.DeviceAttributeDescription.name)
}

// .mascot.CmdArgType dataType = 2;
inline void DeviceAttributeDescription::clear_datatype() {
  datatype_ = 0;
}
inline ::mascot::CmdArgType DeviceAttributeDescription::_internal_datatype() const {
  return static_cast< ::mascot::CmdArgType >(datatype_);
}
inline ::mascot::CmdArgType DeviceAttributeDescription::datatype() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttributeDescription.dataType)
  return _internal_datatype();
}
inline void DeviceAttributeDescription::_internal_set_datatype(::mascot::CmdArgType value) {
  
  datatype_ = value;
}
inline void DeviceAttributeDescription::set_datatype(::mascot::CmdArgType value) {
  _internal_set_datatype(value);
  // @@protoc_insertion_point(field_set:mascot.DeviceAttributeDescription.dataType)
}

// bool writable = 3;
inline void DeviceAttributeDescription::clear_writable() {
  writable_ = false;
}
inline bool DeviceAttributeDescription::_internal_writable() const {
  return writable_;
}
inline bool DeviceAttributeDescription::writable() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttributeDescription.writable)
  return _internal_writable();
}
inline void DeviceAttributeDescription::_internal_set_writable(bool value) {
  
  writable_ = value;
}
inline void DeviceAttributeDescription::set_writable(bool value) {
  _internal_set_writable(value);
  // @@protoc_insertion_point(field_set:mascot.DeviceAttributeDescription.writable)
}

// -------------------------------------------------------------------

// AttributeListReply

// repeated .mascot.DeviceAttributeDescription attributes = 1;
inline int AttributeListReply::_internal_attributes_size() const {
  return attributes_.size();
}
inline int AttributeListReply::attributes_size() const {
  return _internal_attributes_size();
}
inline void AttributeListReply::clear_attributes() {
  attributes_.Clear();
}
inline ::mascot::DeviceAttributeDescription* AttributeListReply::mutable_attributes(int index) {
  // @@protoc_insertion_point(field_mutable:mascot.AttributeListReply.attributes)
  return attributes_.Mutable(index);
}
inline ::PROTOBUF_NAMESPACE_ID::RepeatedPtrField< ::mascot::DeviceAttributeDescription >*
AttributeListReply::mutable_attributes() {
  // @@protoc_insertion_point(field_mutable_list:mascot.AttributeListReply.attributes)
  return &attributes_;
}
inline const ::mascot::DeviceAttributeDescription& AttributeListReply::_internal_attributes(int index) const {
  return attributes_.Get(index);
}
inline const ::mascot::DeviceAttributeDescription& AttributeListReply::attributes(int index) const {
  // @@protoc_insertion_point(field_get:mascot.AttributeListReply.attributes)
  return _internal_attributes(index);
}
inline ::mascot::DeviceAttributeDescription* AttributeListReply::_internal_add_attributes() {
  return attributes_.Add();
}
inline ::mascot::DeviceAttributeDescription* AttributeListReply::add_attributes() {
  // @@protoc_insertion_point(field_add:mascot.AttributeListReply.attributes)
  return _internal_add_attributes();
}
inline const ::PROTOBUF_NAMESPACE_ID::RepeatedPtrField< ::mascot::DeviceAttributeDescription >&
AttributeListReply::attributes() const {
  // @@protoc_insertion_point(field_list:mascot.AttributeListReply.attributes)
  return attributes_;
}

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// DeviceCommandDescription

// string name = 1;
inline void DeviceCommandDescription::clear_name() {
  name_.ClearToEmpty(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
}
inline const std::string& DeviceCommandDescription::name() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceCommandDescription.name)
  return _internal_name();
}
inline void DeviceCommandDescription::set_name(const std::string& value) {
  _internal_set_name(value);
  // @@protoc_insertion_point(field_set:mascot.DeviceCommandDescription.name)
}
inline std::string* DeviceCommandDescription::mutable_name() {
  // @@protoc_insertion_point(field_mutable:mascot.DeviceCommandDescription.name)
  return _internal_mutable_name();
}
inline const std::string& DeviceCommandDescription::_internal_name() const {
  return name_.Get();
}
inline void DeviceCommandDescription::_internal_set_name(const std::string& value) {
  
  name_.Set(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), value, GetArena());
}
inline void DeviceCommandDescription::set_name(std::string&& value) {
  
  name_.Set(
    &::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::move(value), GetArena());
  // @@protoc_insertion_point(field_set_rvalue:mascot.DeviceCommandDescription.name)
}
inline void DeviceCommandDescription::set_name(const char* value) {
  GOOGLE_DCHECK(value != nullptr);
  
  name_.Set(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::string(value),
              GetArena());
  // @@protoc_insertion_point(field_set_char:mascot.DeviceCommandDescription.name)
}
inline void DeviceCommandDescription::set_name(const char* value,
    size_t size) {
  
  name_.Set(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), ::std::string(
      reinterpret_cast<const char*>(value), size), GetArena());
  // @@protoc_insertion_point(field_set_pointer:mascot.DeviceCommandDescription.name)
}
inline std::string* DeviceCommandDescription::_internal_mutable_name() {
  
  return name_.Mutable(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
}
inline std::string* DeviceCommandDescription::release_name() {
  // @@protoc_insertion_point(field_release:mascot.DeviceCommandDescription.name)
  return name_.Release(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), GetArena());
}
inline void DeviceCommandDescription::set_allocated_name(std::string* name) {
  if (name != nullptr) {
    
  } else {
    
  }
  name_.SetAllocated(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(), name,
      GetArena());
  // @@protoc_insertion_point(field_set_allocated:mascot.DeviceCommandDescription.name)
}
inline std::string* DeviceCommandDescription::unsafe_arena_release_name() {
  // @@protoc_insertion_point(field_unsafe_arena_release:mascot.DeviceCommandDescription.name)
  GOOGLE_DCHECK(GetArena() != nullptr);
  
  return name_.UnsafeArenaRelease(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(),
      GetArena());
}
inline void DeviceCommandDescription::unsafe_arena_set_allocated_name(
    std::string* name) {
  GOOGLE_DCHECK(GetArena() != nullptr);
  if (name != nullptr) {
    
  } else {
    
  }
  name_.UnsafeArenaSetAllocated(&::PROTOBUF_NAMESPACE_ID::internal::GetEmptyStringAlreadyInited(),
      name, GetArena());
  // @@protoc_insertion_point(field_unsafe_arena_set_allocated:mascot.DeviceCommandDescription.name)
}

// map<string, .mascot.CmdArgType> parameters = 2;
inline int DeviceCommandDescription::_internal_parameters_size() const {
  return parameters_.size();
}
inline int DeviceCommandDescription::parameters_size() const {
  return _internal_parameters_size();
}
inline void DeviceCommandDescription::clear_parameters() {
  parameters_.Clear();
}
inline const ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >&
DeviceCommandDescription::_internal_parameters() const {
  return parameters_.GetMap();
}
inline const ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >&
DeviceCommandDescription::parameters() const {
  // @@protoc_insertion_point(field_map:mascot.DeviceCommandDescription.parameters)
  return _internal_parameters();
}
inline ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >*
DeviceCommandDescription::_internal_mutable_parameters() {
  return parameters_.MutableMap();
}
inline ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >*
DeviceCommandDescription::mutable_parameters() {
  // @@protoc_insertion_point(field_mutable_map:mascot.DeviceCommandDescription.parameters)
  return _internal_mutable_parameters();
}

// map<string, .mascot.CmdArgType> returnValues = 3;
inline int DeviceCommandDescription::_internal_returnvalues_size() const {
  return returnvalues_.size();
}
inline int DeviceCommandDescription::returnvalues_size() const {
  return _internal_returnvalues_size();
}
inline void DeviceCommandDescription::clear_returnvalues() {
  returnvalues_.Clear();
}
inline const ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >&
DeviceCommandDescription::_internal_returnvalues() const {
  return returnvalues_.GetMap();
}
inline const ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >&
DeviceCommandDescription::returnvalues() const {
  // @@protoc_insertion_point(field_map:mascot.DeviceCommandDescription.returnValues)
  return _internal_returnvalues();
}
inline ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >*
DeviceCommandDescription::_internal_mutable_returnvalues() {
  return returnvalues_.MutableMap();
}
inline ::PROTOBUF_NAMESPACE_ID::Map< std::string, ::mascot::CmdArgType >*
DeviceCommandDescription::mutable_returnvalues() {
  // @@protoc_insertion_point(field_mutable_map:mascot.DeviceCommandDescription.returnValues)
  return _internal_mutable_returnvalues();
}

// -------------------------------------------------------------------

// CommandListReply

// repeated .mascot.DeviceCommandDescription commands = 1;
inline int CommandListReply::_internal_commands_size() const {
  return commands_.size();
}
inline int CommandListReply::commands_size() const {
  return _internal_commands_size();
}
inline void CommandListReply::clear_commands() {
  commands_.Clear();
}
inline ::mascot::DeviceCommandDescription* CommandListReply::mutable_commands(int index) {
  // @@protoc_insertion_point(field_mutable:mascot.CommandListReply.commands)
  return commands_.Mutable(index);
}
inline ::PROTOBUF_NAMESPACE_ID::RepeatedPtrField< ::mascot::DeviceCommandDescription >*
CommandListReply::mutable_commands() {
  // @@protoc_insertion_point(field_mutable_list:mascot.CommandListReply.commands)
  return &commands_;
}
inline const ::mascot::DeviceCommandDescription& CommandListReply::_internal_commands(int index) const {
  return commands_.Get(index);
}
inline const ::mascot::DeviceCommandDescription& CommandListReply::commands(int index) const {
  // @@protoc_insertion_point(field_get:mascot.CommandListReply.commands)
  return _internal_commands(index);
}
inline ::mascot::DeviceCommandDescription* CommandListReply::_internal_add_commands() {
  return commands_.Add();
}
inline ::mascot::DeviceCommandDescription* CommandListReply::add_commands() {
  // @@protoc_insertion_point(field_add:mascot.CommandListReply.commands)
  return _internal_add_commands();
}
inline const ::PROTOBUF_NAMESPACE_ID::RepeatedPtrField< ::mascot::DeviceCommandDescription >&
CommandListReply::commands() const {
  // @@protoc_insertion_point(field_list:mascot.CommandListReply.commands)
  return commands_;
}

// -------------------------------------------------------------------

// PingMessage

// -------------------------------------------------------------------

// PingReply

// int64 time = 1;
inline void PingReply::clear_time() {
  time_ = PROTOBUF_LONGLONG(0);
}
inline ::PROTOBUF_NAMESPACE_ID::int64 PingReply::_internal_time() const {
  return time_;
}
inline ::PROTOBUF_NAMESPACE_ID::int64 PingReply::time() const {
  // @@protoc_insertion_point(field_get:mascot.PingReply.time)
  return _internal_time();
}
inline void PingReply::_internal_set_time(::PROTOBUF_NAMESPACE_ID::int64 value) {
  
  time_ = value;
}
inline void PingReply::set_time(::PROTOBUF_NAMESPACE_ID::int64 value) {
  _internal_set_time(value);
  // @@protoc_insertion_point(field_set:mascot.PingReply.time)
}

#ifdef __GNUC__
  #pragma GCC diagnostic pop
#endif  // __GNUC__
// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------


// @@protoc_insertion_point(namespace_scope)

}  // namespace mascot

// @@protoc_insertion_point(global_scope)

#include <google/protobuf/port_undef.inc>
#endif  // GOOGLE_PROTOBUF_INCLUDED_GOOGLE_PROTOBUF_INCLUDED_device_2eproto
